"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var path_1 = require("path");
var graphql_1 = require("graphql");
var graphql_sequelize_1 = require("graphql-sequelize");
var dataloader_sequelize_1 = require("dataloader-sequelize");
var lodash_1 = require("lodash");
var helper = require("./helpers");
// Dir for customs graphs
var customQueryPath = path_1.join(path_1.dirname(require.main.filename), 'custom');
// Cache fix
var cache = {};
// Dataloader ⭐️
graphql_sequelize_1.resolver.contextToOptions = {
    dataloaderContext: [dataloader_sequelize_1.EXPECTED_OPTIONS_KEY]
};
/**
 * Returns the association fields of an entity.
 *
 * It iterates over all the associations and produces an object compatible with GraphQL-js.
 * BelongsToMany and HasMany associations are represented as a `GraphQLList` whereas a BelongTo
 * is simply an instance of a type.
 * @param {*} associations A collection of sequelize associations
 * @param {*} types Existing `GraphQLObjectType` types, created from all the Sequelize models
 */
exports.generateAssociationFields = function (associations, types, isInput) {
    if (isInput === void 0) { isInput = false; }
    var fields = {};
    for (var associationName in associations) {
        var relation = associations[associationName];
        // BelongsToMany is represented as a list, just like HasMany
        var type = relation.associationType === 'BelongsToMany' ||
            relation.associationType === 'HasMany'
            ? new graphql_1.GraphQLList(types[relation.target.name])
            : types[relation.target.name];
        fields[associationName] = { type: type };
        if (!isInput) {
            // GraphQLInputObjectType do not accept fields with resolve
            fields[associationName].resolve = graphql_sequelize_1.resolver(relation);
        }
    }
    return fields;
};
/**
 * Returns a new `GraphQLObjectType` created from a sequelize model.
 *
 * It creates a `GraphQLObjectType` object with a name and fields. The
 * fields are generated from its sequelize associations.
 * @param {*} model The sequelize model used to create the `GraphQLObjectType`
 * @param {*} types Existing `GraphQLObjectType` types, created from all the Sequelize models
 */
var TypeName = function (modelName) {
    var pieces = modelName.split('_');
    var name = '';
    if (pieces.length > 1) {
        name = pieces.map(function (n) { return lodash_1.default.startCase(lodash_1.default.toLower(n)); }).join('');
    }
    else {
        name = lodash_1.default.startCase(modelName).split(' ').map(function (n) { return n; }).join('');
    }
    return name.split(' ').map(function (n) { return n; }).join('');
};
exports.generateGraphQLType = function (model, types, isInput) {
    if (isInput === void 0) { isInput = false; }
    var GraphQLClass = isInput ? graphql_1.GraphQLInputObjectType : graphql_1.GraphQLObjectType;
    var typeName = TypeName(model.name); //model.name.split('_').map( n => _.startCase(_.toLower(n))  ).join('').replace(' ', '')
    return new GraphQLClass({
        name: isInput ? typeName + "Input" : typeName,
        fields: function () { return Object.assign(graphql_sequelize_1.attributeFields(model, {
            exclude: ['contrasena'],
            allowNull: !!isInput,
            cache: cache
        }), exports.generateAssociationFields(model.associations, types, isInput)); },
        description: "The name of the model is " + model.name + ", this comment is generated automatically."
    });
};
/**
 * Returns a collection of `GraphQLObjectType` generated from Sequelize models.
 *
 * It creates an object whose properties are `GraphQLObjectType` created
 * from Sequelize models.
 * @param {*} models The sequelize models used to create the types
 */
exports.generateModelTypes = function (models) {
    var outputTypes = {};
    var inputTypes = {};
    for (var modelName in models) {
        // Only our models, not Sequelize or sequelize
        if (models[modelName].hasOwnProperty('name') && modelName !== 'Sequelize' && modelName !== 'sequelize' && modelName !== 'Op' && modelName !== 'associate') {
            outputTypes[modelName] = exports.generateGraphQLType(models[modelName], outputTypes);
            inputTypes[modelName] = exports.generateGraphQLType(models[modelName], inputTypes, true);
        }
    }
    return { outputTypes: outputTypes, inputTypes: inputTypes };
};
exports.infoType = new graphql_1.GraphQLObjectType({
    name: 'info',
    fields: function () { return ({
        total: { type: graphql_1.GraphQLInt },
        pageSize: { type: graphql_1.GraphQLInt },
        page: { type: graphql_1.GraphQLInt },
    }); },
    description: 'Type for api pagination'
});
/**
 * Returns a root `GraphQLObjectType` used as query for `GraphQLSchema`.
 *
 * It creates an object whose properties are `GraphQLObjectType` created
 * from Sequelize models.
 * @param {*} models The sequelize models used to create the root `GraphQLSchema`
 */
exports.generateQueryRootType = function (models, outputTypes) {
    var fields = Object.keys(outputTypes).reduce(function (fields, modelTypeName) {
        var _a;
        var modelType = outputTypes[modelTypeName];
        return Object.assign(fields, (_a = {},
            _a[lodash_1.default.lowerFirst(modelType.name)] = {
                type: new graphql_1.GraphQLList(modelType),
                args: Object.assign(graphql_sequelize_1.defaultArgs(models[modelTypeName]), graphql_sequelize_1.defaultListArgs()),
                resolve: graphql_sequelize_1.resolver(models[modelTypeName])
            },
            _a[lodash_1.default.lowerFirst(modelType.name + 'Pagination')] = {
                type: new graphql_1.GraphQLObjectType({
                    name: modelType.name + 'Result',
                    fields: function () { return ({
                        info: {
                            type: exports.infoType
                        },
                        results: {
                            type: new graphql_1.GraphQLList(modelType)
                        }
                    }); }
                }),
                args: Object.assign(graphql_sequelize_1.defaultArgs(models[modelTypeName]), {
                    page: {
                        type: graphql_1.GraphQLInt
                    },
                    pageSize: {
                        type: graphql_1.GraphQLInt
                    },
                    order: {
                        type: new graphql_1.GraphQLList(new graphql_1.GraphQLList(graphql_1.GraphQLString))
                    }
                }),
                resolve: function (parent, args, context) {
                    var _a;
                    var options = {};
                    if (args['where']) {
                        var whereObjectParsed = args['where'];
                        for (var key in args['where']) {
                            var value = args['where'][key];
                            if (value && typeof value === 'string' && value.includes('%')) {
                                whereObjectParsed[key] = (_a = {}, _a[models.Op.like] = value, _a);
                            }
                        }
                        options['where'] = whereObjectParsed;
                    }
                    if (args['order']) {
                        options['order'] = args['order'];
                    }
                    options['limit'] = args['pageSize'] ? parseInt(args['pageSize']) : 10;
                    options['offset'] = args['page'] ? (args['page'] - 1) * options['limit'] : 0;
                    if (!options[dataloader_sequelize_1.EXPECTED_OPTIONS_KEY]) {
                        options[dataloader_sequelize_1.EXPECTED_OPTIONS_KEY] = context['dataloaderContext'] || context;
                    }
                    return models[modelTypeName].findAndCountAll(options).then(function (result) { return ({
                        info: {
                            total: result.count,
                            pageSize: options['limit'],
                            page: args['page'] || 1
                        },
                        results: result.rows
                    }); });
                }
            },
            _a));
    }, {});
    var customQueries = {};
    if (fs.existsSync(customQueryPath + "/query")) {
        fs.readdirSync(customQueryPath + "/query")
            .filter(function (file) { return file.slice(-3) === '.ts'; })
            .forEach(function (file) {
            var objQuery = require(customQueryPath + "/query/" + file);
            if (!objQuery['name'])
                objQuery['name'] = file.replace('.ts', '');
            customQueries[objQuery['name']] = objQuery.default;
        });
    }
    return new graphql_1.GraphQLObjectType({
        name: 'Root_Query',
        fields: Object.assign(fields, customQueries)
    });
};
exports.generateMutationRootType = function (models, inputTypes, outputTypes) {
    var fields = Object.keys(inputTypes).reduce(function (fields, inputTypeName) {
        var _a, _b, _c, _d;
        if (inputTypeName !== 'associate') {
            var inputType = inputTypes[inputTypeName];
            var key_1 = models[inputTypeName].primaryKeyAttributes[0];
            // TODO: Deep hasmany associations
            var includeArrayModels_1 = exports.getDeepAssociations(inputTypeName, models);
            // UpperCase 
            var inputTypeNameUpperCase = inputTypeName.split('_').map(function (s, i) { return i == 0 ? s : lodash_1.default.upperFirst(s); }).join('');
            var toReturn = Object.assign(fields, (_a = {},
                _a[inputTypeNameUpperCase + 'Create'] = {
                    type: outputTypes[inputTypeName],
                    description: 'Create a ' + inputTypeName,
                    args: (_b = {},
                        _b[inputTypeName] = { type: inputType },
                        _b),
                    resolve: function (source, args, context, info) {
                        return models[inputTypeName].create(args[inputTypeName], { include: includeArrayModels_1 });
                    }
                },
                _a[inputTypeNameUpperCase + 'Update'] = {
                    type: outputTypes[inputTypeName],
                    description: 'Update a ' + inputTypeName,
                    args: (_c = {},
                        _c[inputTypeName] = { type: inputType },
                        _c),
                    resolve: function (source, args, context, info) {
                        var _a;
                        var options = {
                            where: (_a = {},
                                _a[key_1] = args[inputTypeName][key_1],
                                _a),
                            include: includeArrayModels_1
                        };
                        if (!options[dataloader_sequelize_1.EXPECTED_OPTIONS_KEY]) {
                            options[dataloader_sequelize_1.EXPECTED_OPTIONS_KEY] = context['dataloaderContext'] || context;
                        }
                        // [INFO] Si se manda detalles actualizar los detalles tambien (includes)
                        return models[inputTypeName].findOne(options).then(function (object2Update) {
                            var promises = [];
                            includeArrayModels_1.forEach(function (m) {
                                var model = m.model;
                                if (model.options && model.options.name && model.options.name.plural) {
                                    if (model.options.name.plural in args[inputTypeName]) {
                                        promises.push(helper.upsertArray(model.options.name.plural, args[inputTypeName][model.options.name.plural], object2Update, inputTypeName + "_id", args[inputTypeName][key_1], m.include, models));
                                    }
                                }
                            });
                            // Actualizar datos
                            promises.push(object2Update.update(args[inputTypeName]));
                            return Promise.all(promises).then(function (ups) {
                                // `boolean` equals the number of rows affected (0 or 1)
                                return graphql_sequelize_1.resolver(models[inputTypeName])(source, options.where, context, info);
                            });
                        });
                    }
                },
                _a[inputTypeNameUpperCase + 'Delete'] = {
                    type: graphql_1.GraphQLInt,
                    description: 'Delete a ' + inputTypeName,
                    args: (_d = {},
                        _d[key_1] = { type: new graphql_1.GraphQLNonNull(graphql_1.GraphQLInt) },
                        _d),
                    resolve: function (value, where) { return models[inputTypeName].destroy({ where: where }); } // Returns the number of rows affected (0 or 1)
                },
                _a));
            return toReturn;
        }
    }, {});
    var customQueries = {};
    if (fs.existsSync(customQueryPath + "/mutation")) {
        fs.readdirSync(customQueryPath + "/mutation")
            .filter(function (file) { return file.slice(-3) === '.ts'; })
            .forEach(function (file) {
            var objQuery = require(customQueryPath + "/mutation/" + file);
            if (!objQuery['name'])
                objQuery['name'] = file.replace('.ts', '');
            customQueries[objQuery['name']] = objQuery;
        });
    }
    return new graphql_1.GraphQLObjectType({
        name: 'Root_Mutations',
        fields: Object.assign(fields, customQueries)
    });
};
exports.getDeepAssociations = function (modelName, models) {
    var associations = models[modelName].associations, includeArrayModels = [];
    for (var associationName in associations) {
        var relation = associations[associationName];
        if (relation.associationType === 'HasMany') {
            includeArrayModels.push({ model: models[relation.target.name], include: exports.getDeepAssociations(relation.target.name, models) });
        }
    }
    return includeArrayModels;
};
exports.GroupModels = function (dbs) {
    var _a;
    var models = {};
    for (var db in dbs) {
        for (var key in dbs[db])
            if (key !== 'sequelize' && key !== 'Sequelize' && key !== 'Op' && key !== 'associate')
                models = __assign(__assign({}, models), (_a = {}, _a["" + key] = dbs[db][key], _a));
    }
    return models;
};
// This function is exported
exports.generateSchema = function (dbs, types) {
    if (types === void 0) { types = null; }
    return __awaiter(void 0, void 0, void 0, function () {
        var models, modelTypes, queries, mutations;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    models = exports.GroupModels(dbs);
                    modelTypes = types !== null ? types : exports.generateModelTypes(models);
                    return [4 /*yield*/, exports.generateQueryRootType(models, modelTypes.outputTypes)];
                case 1:
                    queries = _a.sent();
                    return [4 /*yield*/, exports.generateMutationRootType(models, modelTypes.inputTypes, modelTypes.outputTypes)];
                case 2:
                    mutations = _a.sent();
                    return [2 /*return*/, {
                            query: queries,
                            mutation: mutations
                        }];
            }
        });
    });
};
