"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require('lodash');
exports.upsert = function (modelName, data, idField, models) {
    var where = {};
    if (typeof idField === 'string') {
        where[idField] = data[idField];
    }
    else {
        idField.forEach(function (f) {
            where[f] = data[f];
        });
    }
    return models[modelName].findOne({
        where: where
    }).then(function (info) {
        if (info) {
            // Update
            return info.update(data).then(function (res) { return info; });
        }
        else {
            // Insert
            return models[modelName].create(data);
        }
    });
};
exports.upsertArray = function (array_name, array_data, object_data, father_id, id, modelInclude, models) {
    if (modelInclude === void 0) { modelInclude = []; }
    var promises = [];
    if (Array.isArray(array_data)) {
        if (Array.isArray(object_data[array_name])) {
            promises = object_data[array_name].map(function (detalle) {
                var promise = null;
                var found = _.find(array_data, { id: detalle.id });
                if (found) {
                    promise = detalle.update(found);
                    modelInclude.forEach(function (m) {
                        if (m && m.model && m.model.options && m.model.options.name && m.model.options.name.plural) {
                            if (m.model.options.name.plural in found) {
                                if (found.id) {
                                    promises.push(models[array_name.slice(0, -1)].findOne({
                                        where: {
                                            id: found.id
                                        },
                                        include: modelInclude
                                    }).then(function (object2Update) {
                                        return module.exports.upsertArray(m.model.options.name.plural, found[m.model.options.name.plural], object2Update, array_name.slice(0, -1) + "_id", found.id, m.include, models);
                                    }));
                                }
                            }
                        }
                    });
                    _.remove(array_data, { id: found.id });
                }
                else {
                    // Delete
                    promise = detalle.destroy();
                }
                return promise;
            });
        }
        array_data.forEach(function (dat) {
            delete dat['id'];
            dat[father_id] = id;
            promises.push(models[array_name.slice(0, -1)].create(dat, { include: modelInclude }));
        });
    }
    return promises;
};
exports.strip_html_tags = function (str) {
    if ((str === null) || (str === ''))
        return false;
    else
        str = str.toString();
    return str.replace(/<[^>]*>/g, '');
};
exports.cleanExtraSpacing = function (string) { return (string || "").trim().replace(/\s+/g, " "); };
exports.randomNumber = function (low, high) { return Math.floor(Math.random() * (high - low) + low); };
exports.getOperatorByString = function (str) {
    var operators = ['*', '/', '+', '-'];
    var returnVar = [];
    operators.forEach(function (o) {
        if (str.includes(o)) {
            var _a = str.split(o), op1 = _a[0], op2 = _a[1];
            returnVar[o] = [];
            if (isNaN(op1)) {
                // field
                returnVar.push({
                    type: 'field',
                    value: op1.trim()
                });
            }
            else {
                // Numero 
                returnVar.push({
                    type: 'number',
                    value: parseFloat(op1)
                });
            }
        }
    });
    if (Object.keys(returnVar).length === 0)
        returnVar['field'] = str.trim();
    return returnVar;
};
